'
' READER.BAS
'
' Edit EMAIL.INC before compiling.
' Compile & link: PBCC READER.BAS
'

$INCLUDE "SEE32.BAS"

GLOBAL ArgVal() As String
$INCLUDE "GETARGS.BAS"

Sub ShowError(Code As Long)
Dim N As Long
Dim Buffer As Asciiz * 128
N = seeErrorText(Code,Buffer,128)
PRINT Buffer 
End Sub

FUNCTION PbMain() AS LONG
$INCLUDE "EMAIL.INC"
Dim I As Integer
Dim N As Integer
Dim NbrMsg As Long
Dim MsgNbr As Long
Dim BytesRead As Long
Dim LastRead As Long
Dim Code As Long
Dim ArgVal(10) As String
Dim NullString As Asciiz * 2
Dim Version As Integer
Dim DiagFile As Asciiz * 64
Dim A As String
Dim B As String
Dim C As String
Dim FileName As Asciiz * 64
Dim EmailDir As Asciiz * 64
Dim AttachDir As Asciiz * 64

PRINT "READER 10/2/98"

' display SEE version
Version = seeStatistics(%SEE_GET_VERSION)
C = Hex$(&HF And Version)
Version = Version / 16
B = Hex$(&HF And Version)
Version = Version / 16
A = Hex$(&HF And Version)
PRINT "SEE Version " + A + "." + B + "." + C

NullString = Chr$(0)

' get command line arguments
N = GetArgs()

IF N <> 2 THEN
  PRINT "Usage: READER message_nbr message_filename"
  PRINT "   eg: READER 1 message.mai"; 
  Exit Function
END IF  

' gets ASCIIZ version of argument strings
MsgNbr = VAL(ArgVal(1))
Filename = ArgVal(2)
EmailDir = "."
AttachDir = "."

' define diagnostics log file 
DiagFile = "READER.LOG"
Code = seeStringParam(%SEE_LOG_FILE, DiagFile) 

' connect to the POP3 server 
PRINT "Connecting to ";POP3_HOST_NAME
Code = seePop3Connect(POP3_HOST_NAME, POP3_USER_NAME, POP3_PASSWORD)  
IF Code < 0 THEN
  Call ShowError(Code)
  EXIT Function
END IF 

' get # messages waiting  
PRINT "Getting message status..."
NbrMsg = seeGetEmailCount()                  
IF NbrMsg < 0 THEN 
  Call ShowError(NbrMsg)
  EXIT Function
END IF  
PRINT NbrMsg;" messages waiting."
' any email on the server ?
If NbrMsg = 0 Then
  PRINT "You no email waiting on the server."
  Exit Function
End If
' does the server have this message # ?
If (MsgNbr=0) OR (MsgNbr>NbrMsg) Then
  PRINT "There is no message # ";MsgNbr
  Exit Function
End If  

' disable AUTO CALL [see Users Manual SEE4VB_U.TXT]
Code = seeIntegerParam(%SEE_AUTO_CALL_DRIVER, 0&)
' setup to read message MsgNbr
Code = seeGetEmailFile(MsgNbr, FileName, EmailDir, AttachDir)
PRINT "Reading message # ";MsgNbr;" to file ";FileName
' read email using seeDriver
LastRead = 0
Do
  ' execute next state
  Code = seeDriver()
  If Code = 0 Then
    ' driver is done
    Exit Do
  End If
  If Code < 0 Then
    'driver returned error
    Call ShowError(Code)
    Exit Do
  End If
  ' driver not yet done, so report progress.
  BytesRead = seeStatistics(%SEE_GET_TOTAL_BYTES_READ)
  Locate CursorY, 1
  If BytesRead <> LastRead Then
    PRINT Str$(BytesRead) + " bytes read.";
    LastRead = BytesRead
  End if
Loop
PRINT
' re-enable AUTO CALL
Code = seeIntegerParam(%SEE_AUTO_CALL_DRIVER, 1&)
PRINT "Email sent."
Code = seeClose()
END FUNCTION
